<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="page_ble_section_more_information" kind="group">
    <compoundname>page_ble_section_more_information</compoundname>
    <title>More Information</title>
    <detaileddescription>

<para><heading level="1">Operation Flow</heading></para>
<para>A typical application code implements three operating modes: initialization, normal operation, and low-power operation. Initialization should happen only at system power-up, or when waking from system hibernation. After initialization, the PSoC 6 BLE Middleware enters normal operation and periodically enters various degrees of low-power operation to conserve power.</para><para><simplesect kind="par"><title>System Initialization </title><para>The initialization stage happens at system power-up or when waking from system hibernation. This stage sets up the platform and the PSoC 6 BLE Middleware parameters. The application code should also start the PSoC 6 BLE Middleware and set up the callback functions for the event callbacks that happen in the other modes of operation.</para></simplesect>
<simplesect kind="par"><title>System Normal Operation </title><para>Upon successful initialization of the PSoC 6 BLE Middleware or hibernate wakeup sequence, the PSoC 6 BLE Middleware enters normal mode. Normal operation first establishes a BLE connection if it is not already connected. It should then call <ref kindref="member" refid="group__group__ble__common__api__functions_1ga0f1982f915c28b0d5a317442bec9eafc">Cy_BLE_ProcessEvents()</ref> to process all pending BLE events. When queue of BLE events is not full (<ref kindref="member" refid="group__group__ble__common__api__gatt__functions_1gabe19ddf74bbc0b62180a1ea33f3d8553">Cy_BLE_GATT_GetBusyStatus()</ref> returns CY_BLE_STACK_STATE_FREE), it can transmit any data that need to be communicated and enter low-power operation, unless there is another pending event. In that case it should execute the normal operation flow again. Processing of BLE events should be performed at least once in a BLE connection event period. The BLE connection event is configured by the Central device while establishing a connection.</para></simplesect>
<simplesect kind="par"><title>System Low-power Operation </title><para>When there are no pending interrupts in normal operation, the BLE Sub-System (BLESS) can be placed in low-power mode. All the high frequency blocks in BLESS are shutdown and the BLE link layer timing is maintained using low frequency clocks (WCO or PILO). CPU will not be able to access the BLESS registers in this mode. If an event happens at any time in low-power mode, it should re-enter normal operation.</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The MCU and BLESS have separate power modes and are able to go to different power modes independent of each other. The check marks in the following table show the possible combination of power modes of MCU and BLES &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="par"><title /><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head" rowspan="2"&gt;&lt;p&gt;BLESS&lt;br /&gt;Power Modes &lt;/p&gt;&lt;/td&gt;&lt;td class="head" colspan="4"&gt;&lt;p&gt;MCU Power Modes  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Active &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Sleep &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Deep sleep &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Hibernate  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Active (idle/Tx/Rx) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Y &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Y &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Deep sleep (ECO off) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Y &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Y &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Y &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Off &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Y  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para></simplesect>
To better understand of BLE operation flow refer <ref kindref="compound" refid="page_ble_quick_start">Quick Start Guide</ref> section based on simple BLE example project.</para>

<para><heading level="1">Device Bonding</heading></para>
<para>The PSoC 6 BLE Middleware stores the link key of a connection after pairing with the remote device. If a connection is lost and re-established, the devices use the previously stored key for the connection. The BLE stack updates the bonding data in RAM while the devices are connected. If the bonding data is to be retained during shutdown, the application can use <ref kindref="member" refid="group__group__ble__common__api__functions_1ga778852ddcd6a37606668984aca7c3754">Cy_BLE_StoreBondingData()</ref> API to write the bonding data from RAM to the dedicated flash location, as defined by the PSoC 6 BLE Middleware.</para><para>Refer to the <ulink url="https://github.com/cypresssemiconductorco/PSoC-6-MCU-BLE-Connectivity-Designs/tree/master/CE215121_BLE_HID_Keyboard/CE215121_BLE_HID_Keyboard.cydsn">CE215121_BLE_HID_Keyboard</ulink> code example for usage details.</para>

<para><heading level="1">LFCLK Configuration for BLESS Deep Sleep Mode</heading></para>
<para>The LFCLK configuration affects the PSoC 6 BLE Middleware's ability to operate in BLESS deep sleep mode. If the WCO or PILO are chosen as source clock, then the PSoC 6 BLE Middleware BLESS deep sleep mode is available for use. However, if the ILO is chosen, then the PSoC 6 BLE Middleware cannot enter BLESS deep sleep.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The PSoC 6 BLE Middleware uses the LFCLK only during BLESS deep sleep mode, so ILO inaccuracy does not affect BLE communication.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><bold>Configuring PILO for BLESS Deep Sleep Mode</bold></para>
<para>The PSoC 6 BLE Middleware supports using the Precision ILO (PILO) (instead of the WCO) as the LF clock source.</para><para>Using the PILO has limitations:<itemizedlist>
<listitem><para>supports only a single connection</para></listitem><listitem><para>supports only the Peripheral/Slave role</para></listitem><listitem><para>not supported for preproduction hardware.</para></listitem></itemizedlist>
</para><para>Using the PILO as the LF clock source requires:<itemizedlist>
<listitem><para>configure BLE ECO (AltHF) clock in ModusToolbox Device Configurator. The recommended frequency is 16 Mhz.</para></listitem><listitem><para>initial trimming (call Cy_SysClk_PiloInitialTrim() function) and measuring the step size of the PILO trimming (call Cy_SysClk_PiloUpdateTrimStep function) before BLE start.</para></listitem></itemizedlist>
</para><para>Both actions must happen during every power-up to get closest to the target frequency.</para><para>The following code snippet shows usage: <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />initial<sp />PILO<sp />trimming<sp />and<sp />update<sp />the<sp />trim<sp />step<sp />size.<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />\note:</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />1.<sp />Call<sp />those<sp />functions<sp />after<sp />every<sp />power-up.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />2.<sp />Those<sp />functions<sp />require<sp />a<sp />configured<sp />BLE<sp />ECO<sp />ALTHF<sp />clock.<sp />Use<sp />ModusToolbox<sp />Device<sp />Configurator<sp />to</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp /><sp /><sp /><sp />configure<sp />the<sp />BLE<sp />ECO<sp />BLE<sp />ECO<sp />ALTHF<sp />clock.<sp />The<sp />recommended<sp />frequency<sp />is<sp />16<sp />Mhz.<sp />*/</highlight><highlight class="normal"><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysClk_PiloInitialTrim();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysClk_PiloUpdateTrimStep();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Then<sp />configure<sp />and<sp />enable<sp />BLE<sp />Middleware,<sp />refer<sp />to<sp />Quick<sp />Start<sp />Guide<sp />section<sp />of<sp />BLE<sp />API<sp />Reference<sp />Guide<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting> <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call trimming functions Cy_SysClk_PiloInitialTrim() and Cy_SysClk_PiloUpdateTrimStep() before Cy_BLE_Start(), on the CPU core running the BLE controller.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>


<para><heading level="1">Multi-Connection Support</heading></para>
<para>The PSoC 6 BLE Middleware supports up to four simultaneous Multi-Master Multi-Slave (MMMS) BLE connections in any combination of roles. For example, it can be a master of four slave devices (4M), a master of three slave devices and a slave of another device (3M1S), or a slave of four devices (4S), or any other combination. To configure the maximum number of BLE connections, refer to the <bold>General Tab</bold> section of ModusToolbox Bluetooth Configurator Guide (Maximum number of BLE connections). The PSoC 6 BLE Middleware supports a single instance of a GATT Server (single GATT database). The number of the Server instance field is always fixed to 1 in the Bluetooth Configurator dialog. You can add additional Services or a complete Server Profile to the existing Server tree and build a GATT database. This single GATT database is reused across all BLE connections. The PSoC 6 BLE Middleware manages multiple Client Characteristic Configuration Descriptor (CCCD) values. The CCCD value for each active connection is unique.</para><para>The maximum number of CCCD storage SRAM data structures supported by the PSoC 6 BLE Middleware is determined by the number of active BLE connections/links that you select. The PSoC 6 BLE Middleware restores CCCD values in flash for each of the bonded devices while establishing a connection with a peer device.</para><para>Use the connection handle at the application level to manage the multi-connection. The connection handle (<ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref>) appears when the connection is established (as the event parameter of the <ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86aff4f3e61e6d3125ac81bf0c92be85ab5">CY_BLE_EVT_GATT_CONNECT_IND</ref> event).</para><para>To work with a particular connection, BLE APIs (BLE Stack APIs, BLE Profile APIs) provide the parameter connHandle (e.g., Cy_BLE_BASS_SendNotification(<ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref> connHandle,... ).) BLE events from the AppCallback function include a connHandle in eventParam structures to distinguish to which connection this event relates. The following code shows how an application can manage connection handles: <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Allocate<sp />the<sp />connection<sp />handle<sp />array.<sp />Macro<sp />CY_BLE_CONN_COUNT<sp />indicates<sp />the<sp />MAX<sp />number<sp />of<sp />supported<sp />connection.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref><sp />appConnHandle[CY_BLE_CONN_COUNT]<sp />=<sp />{<sp />{.<ref kindref="member" refid="structcy__stc__ble__conn__handle__t_1a5b7b8e26c680094b51360e4245a252c5">attId</ref><sp />=<sp /><ref kindref="member" refid="group__group__ble__common__api__macros_1ga4f351ae5e87a246f8bfe7ab72f19299f">CY_BLE_INVALID_CONN_HANDLE_VALUE</ref>}<sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp /><sp />The<sp />callback<sp />event<sp />function<sp />to<sp />handle<sp />various<sp />events<sp />from<sp />the<sp />BLE<sp />stack<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />AppCallback1<sp />(uint32<sp />event,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />eventParam)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(event)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*...*/</highlight><highlight class="normal"><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86aff4f3e61e6d3125ac81bf0c92be85ab5">CY_BLE_EVT_GATT_CONNECT_IND</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Add<sp />the<sp />connected<sp />device<sp />to<sp />the<sp />connection<sp />handle<sp />array<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />appConnHandle[<sp />(*(<ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref><sp />*)eventParam).attId<sp />]<sp />=<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*(<ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref><sp />*)<sp />eventParam;<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86af587c72e44312a1c627bc7c2694b804c">CY_BLE_EVT_GATT_DISCONNECT_IND</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Remove<sp />the<sp />connected<sp />device<sp />from<sp />the<sp />connection<sp />handle<sp />array<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />memset(&amp;appConnHandle[(*(<ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref>*)eventParam).attId],<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__macros_1ga4f351ae5e87a246f8bfe7ab72f19299f">CY_BLE_INVALID_CONN_HANDLE_VALUE</ref>,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref>));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*...*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> Loop through all connected devices: <programlisting><codeline><highlight class="comment">/*<sp />Allocate<sp />the<sp />connection<sp />handle<sp />array.<sp />Macro<sp />CY_BLE_CONN_COUNT<sp />indicates<sp />the<sp />MAX<sp />number<sp />of<sp />supported<sp />connection.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__ble__conn__handle__t">cy_stc_ble_conn_handle_t</ref><sp />appConnHandle[CY_BLE_CONN_COUNT]<sp />=<sp />{<sp />{.<ref kindref="member" refid="structcy__stc__ble__conn__handle__t_1a5b7b8e26c680094b51360e4245a252c5">attId</ref><sp />=<sp /><ref kindref="member" refid="group__group__ble__common__api__macros_1ga4f351ae5e87a246f8bfe7ab72f19299f">CY_BLE_INVALID_CONN_HANDLE_VALUE</ref>}<sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />...<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">uint32_t<sp />i;</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(i<sp />=<sp />0;<sp />i<sp />&lt;<sp />CY_BLE_CONN_COUNT;<sp />i++)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__ble__common__api__functions_1gaa8b78b1e8bba23c0916c7d889096fbbd">Cy_BLE_GetConnectionState</ref>(appConnHandle[i])<sp />&gt;=<sp /><ref kindref="member" refid="group__group__ble__common__api__gap__definitions_1ggad0312d72df4feae7292ab7a18944d4b5aa06bd189c8ddb0370e563b2f8e488f10">CY_BLE_CONN_STATE_CONNECTED</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Do<sp />some<sp />action<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />...<sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting> Use the <ref kindref="member" refid="group__group__ble__common__api__functions_1gabc74705f034cd89fa8de16e93e223119">Cy_BLE_GetDeviceRole(cy_stc_ble_conn_handle_t *connHandle)</ref> function to discover the role of the link-layer device connected to a peer device with the connection handle indicated by the connHandle parameter. Write attributes (characteristic, descriptors) requests from the peer device(s) for adopted services (e.g. BAS, HIDS, HRS, etc) handled by the PSoC 6 BLE Middleware.</para><para>For the Custom service, write attributes requests handled by the application level in the AppCallback () callback event function. The following code shows the handling of the Write operation by a peer device for the Custom service: <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Call<sp />the<sp />back<sp />event<sp />function<sp />to<sp />handle<sp />various<sp />events<sp />from<sp />the<sp />BLE<sp />Stack<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />AppCallback2<sp />(uint32<sp />event,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />eventParam)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(event)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*...*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86aacf391a3ca29026b4b969a35a19879d3">CY_BLE_EVT_GATTS_WRITE_REQ</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__gatt__definitions_1ga840a7207c3fa1dd4e5d88f0bdfdceecb">cy_en_ble_gatt_err_code_t</ref><sp />gattErr;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ble__gatt__write__param__t">cy_stc_ble_gatt_write_param_t</ref><sp />*writeParam<sp />=<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(<ref kindref="compound" refid="structcy__stc__ble__gatt__write__param__t">cy_stc_ble_gatt_write_param_t</ref><sp />*)eventParam;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Store<sp />data<sp />in<sp />the<sp />database<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />gattErr<sp />=<sp /><ref kindref="member" refid="group__group__ble__common__api__gatt__server__functions_1ga83833a69e752df584bf934e657269b6b">Cy_BLE_GATTS_WriteAttributeValuePeer</ref>(</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;writeParam-&gt;<ref kindref="member" refid="structcy__stc__ble__gatt__write__param__t_1a7926437b7b01816b49319d26f4cdd9a6">connHandle</ref>,<sp />&amp;writeParam-&gt;<ref kindref="member" refid="structcy__stc__ble__gatt__write__param__t_1a62ac2975d36edbb3490b4d5517bc6d37">handleValPair</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(gattErr<sp />!=<sp /><ref kindref="member" refid="group__group__ble__common__api__gatt__definitions_1gga840a7207c3fa1dd4e5d88f0bdfdceecba5e159f8de5d93311cfbb5d971b7c2190">CY_BLE_GATT_ERR_NONE</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Send<sp />an<sp />Error<sp />Response<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ble__gatt__err__info__t">cy_stc_ble_gatt_err_info_t</ref><sp />errInfo<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__ble__gatt__err__info__t_1a9174ff868ae764005940c2b87d272d6e">opCode</ref><sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__ble__common__api__gatt__definitions_1ggae06f56cc034e0b31fd066f0a12e4324bab3dec0c4dba2fac8fa512b316a63bf4e">CY_BLE_GATT_WRITE_REQ</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.attrHandle<sp />=<sp />writeParam-&gt;<ref kindref="member" refid="structcy__stc__ble__gatt__write__param__t_1a62ac2975d36edbb3490b4d5517bc6d37">handleValPair</ref>.<ref kindref="member" refid="structcy__stc__ble__gatt__handle__value__pair__t_1a7f93d681d87c18f5df2ae66377c0c36d">attrHandle</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.errorCode<sp /><sp />=<sp />gattErr</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__gatt__server__functions_1ga144da11ae3b06cec1d3d52b669ce7882">Cy_BLE_GATTS_SendErrorRsp</ref>(&amp;writeParam-&gt;<ref kindref="member" refid="structcy__stc__ble__gatt__write__param__t_1a7926437b7b01816b49319d26f4cdd9a6">connHandle</ref>,<sp />&amp;errInfo);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*...*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> The common MMMS usage are Multi-Master Single-Slave and Multi-Role when the PSoC 6 BLE Middleware is configured in all the GAP roles (Central, Peripheral, Observer, and Broadcaster).</para><para><bold>Multi-Master Single-Slave Usage Block Diagram</bold>  <image name="ble_multi_master_single_slave_usage_block_diagram.png" type="html" />
</para><para><bold>Multi-Role Usage Block Diagram</bold>  <image name="ble_multi_role_usage_block_diagram.png" type="html" />
</para><para>Refer to code examples <ulink url="https://github.com/cypresssemiconductorco/PSoC-6-MCU-BLE-Connectivity-Designs/tree/master/CE215118_BLE_Multi_Master_Single_Slave/CE215118_BLE_Multi_Master_Single_Slave.cydsn">CE215118_BLE_Multi_Master_Single_Slave</ulink> and <ulink url="https://github.com/cypresssemiconductorco/PSoC-6-MCU-BLE-Connectivity-Designs/tree/master/CE215555_BLE_Multi_Role/CE215555_BLE_Multi_Role.cydsn">CE215555_BLE_Multi_Role</ulink> for more details.</para>

<para><heading level="1">BLE Interrupt Notification Callback</heading></para>
<para>The PSoC 6 BLE Middleware exposes BLE interrupt notifications to the application which indicates a different link layer and radio state transitions to the user from the BLESS interrupt context. The user registers for a particular type of a callback and the PSoC 6 BLE Middleware will call that registered callback basing on the registered mask (Refer to the <ref kindref="member" refid="group__group__ble__common___intr__feature__api__functions_1ga4f1bb36b7bd9cd99410c677a62da061e">Cy_BLE_RegisterInterruptCallback()</ref> and <ref kindref="member" refid="group__group__ble__common___intr__feature__api__functions_1ga9d1d62eec83ccdad2828712553359db8">Cy_BLE_UnRegisterInterruptCallback()</ref> APIs). All interrupts masks are specified in the <ref kindref="member" refid="group__group__ble__common__api__definitions_1ga716607fd63ab34c49af7a84e76239640">cy_en_ble_interrupt_callback_feature_t</ref> enumeration.</para><para>The possible interrupts which can trigger a user callback:<orderedlist>
<listitem><para><bold>CY_BLE_INTR_CALLBACK_BLESS_STACK_ISR</bold> - Executed on every trigger of the BLESS interrupt.</para></listitem><listitem><para><bold>CY_BLE_INTR_CALLBACK_BLESS_INTR_STAT_DSM_EXITED</bold> - Executed when the BLESS exits BLESS deep sleep mode and enters BLESS active mode. A BLESS deep sleep exit can be triggered automatically by link layer hardware or by different PSoC 6 BLE Middleware data transfer APIs, which needs the BLESS to be active.</para></listitem><listitem><para><bold>CY_BLE_INTR_CALLBACK_BLELL_CONN_EXT_INTR_EARLY</bold> - Executed when the BLESS connection engine in Slave mode detects a BLE packet that matches its access address.</para></listitem><listitem><para><bold>CY_BLE_INTR_CALLBACK_BLELL_CONN_INTR_CE_RX</bold> - Executed when the BLESS connection engine receives a non-empty packet from the peer device</para></listitem><listitem><para><bold>CY_BLE_INTR_CALLBACK_BLELL_CONN_INTR_CE_TX_ACK</bold> - Executed when the BLESS connection engine receives an ACK packet from the peer device for the previously transmitted packet.</para></listitem><listitem><para><bold>CY_BLE_INTR_CALLBACK_BLELL_CONN_INTR_CLOSE_CE</bold> - Executed when the BLESS connection engine closes the connection event. This interrupt is executed on every connection interval for connection, irrespective of data tx/rx state.</para></listitem><listitem><para><bold>CY_BLE_INTR_CALLBACK_BLESS_INTR_STAT_DSM_ENTERED</bold> - Executed when the BLESS enters deep sleep mode. A user call to the Cy_SysPm_DeepSleep() function will trigger the BLESS deep sleep entry sequence. A time instance when each of these interrupts (#1 to #7) are triggered in a connection event are shown below (green).</para></listitem><listitem><para><bold>CY_BLE_INTR_CALLBACK_BLELL_SCAN_INTR_ADV_RX</bold> - Executed when the BLESS scan engine receives an advertisement packet from the peer device.</para></listitem><listitem><para><bold>CY_BLE_INTR_CALLBACK_BLELL_SCAN_INTR_SCAN_RSP_RX</bold> - Executed when the BLESS scan engine receives a scan response packet from the peer device in response to a scan request from the scanner.</para></listitem><listitem><para><bold>CY_BLE_INTR_CALLBACK_BLELL_ADV_INTR_CONN_REQ_RX</bold> - Executed when the BLESS advertisement engine receives a connection request from the peer central device.</para></listitem></orderedlist>
</para><para>An application can use these interrupt callbacks to know when the RF activity is about to begin/end or when the BLE device changes its state from advertisement to connected, or when the BLESS transitions between active and low-power modes, etc. These BLESS real-time states can be used to synchronize an application with the BLESS or prevent radio interference with other peripherals etc.</para><para><image name="ble_intr_notify_feature.png" type="html" />
</para><para>To register / un-register a callback following APIs are available: <ref kindref="member" refid="group__group__ble__common___intr__feature__api__functions_1ga4f1bb36b7bd9cd99410c677a62da061e">Cy_BLE_RegisterInterruptCallback()</ref> and <ref kindref="member" refid="group__group__ble__common___intr__feature__api__functions_1ga9d1d62eec83ccdad2828712553359db8">Cy_BLE_UnRegisterInterruptCallback()</ref>.</para>

<para><heading level="1">Unsupported Features</heading></para>
<para>The PSoC 6 BLE Middleware stack does not support the following optional Bluetooth v5.0 protocol features, as listed in Vol 6, Part B, section 4.6 of the specification:<itemizedlist>
<listitem><para>Connection Parameters Request Procedure (Vol 6, Part B, section 4.6.2)</para></listitem><listitem><para>Extended Reject Indication (Vol 6, Part B, section 4.6.3)</para></listitem><listitem><para>Slave-initiated Features Exchange (Vol 6, Part B, section 4.6.4)</para></listitem><listitem><para>Stable Modulation Index - Transmitter (Vol 6, Part B, section 4.6.10)</para></listitem><listitem><para>Stable Modulation Index - Receiver (Vol 6, Part B, section 4.6.11)</para></listitem><listitem><para>LE Extended Advertising (Vol 6, Part B, section 4.6.12)</para></listitem><listitem><para>LE Periodic Advertising (Vol 6, Part B, section 4.6.13)</para></listitem><listitem><para>Channel Selection Algorithm #2 (Vol 6, Part B, section 4.6.14)</para></listitem><listitem><para>Minimum Number of Used Channels Procedure (Vol 6, Part B, section 4.6.15)</para></listitem></itemizedlist>
</para>

<para><heading level="1">Low-power Modes</heading></para>
<para>The PSoC 6 BLE Middleware automatically registers sleep and deep sleep callback functions. These functions request the BLE Stack to put Bluetooth Low Energy Sub-System (BLESS) to low-power mode.</para>

<para><heading level="1">External PA/LNA Support</heading></para>
<para>RF front ends come in a variety of combinations. The most popular and comprehensive RF front ends come with a built-in power amplifier (PA) in the transmit path, a low-noise amplifier (LNA) in the receive path, a transmit/receive bypass path to bypass both the PA and LNA, and RF switches to select between transmit, receive, and bypass paths. Some front ends support multiple antennas. Some front ends have a built-in low-pass filter after the power amplifier. The discrete front ends also have almost the same configuration.</para><para><image name="ble_ext_pa_lna_control.png" type="html" />
</para><para><simplesect kind="par"><title>Chip Enable Signal</title><para>This signal is needed to put the front end to sleep or in standby whenever there is no radio activity. The signal is ON when either PA control or LNA control is ON.</para></simplesect>
<simplesect kind="par"><title>Tx ENABLE</title><para>This signal is turned ON during transmission and turned OFF when not transmitting. This signal is active a little earlier than the actual start of transmission to allow for the time it takes for the Power amplifier to ramp up. This delay can be set in the EXT_PA_LNA_DLY_CNFG register.</para></simplesect>
<simplesect kind="par"><title>Rx ENABLE</title><para>This signal is needed to choose between the bypass path and the LNA path. This signal is ON during reception and OFF when the receiver is OFF. This output is visible if the Enable external LNA Rx control output parameter is selected on the Advanced tab.</para></simplesect>
The polarity of these signals are configurable and can be set in the EXT_PA_LNA_CTRL register by Cy_BLE_ConfigureExtPA() API.</para>

<para><heading level="1">Additional Resources</heading></para>
<para>For more information, refer to the following documents:</para><para><ulink url="https://www.cypress.com/products/modustoolbox-software-environment">ModusToolbox Software Environment, Quick Start Guide, Documentation, and Videos</ulink><linebreak />
 <ulink url="https://github.com/cypresssemiconductorco">PSoC 6 BLE Middleware Code Examples at GITHUB</ulink><linebreak />
 <ulink url="https://www.cypress.com/ModusToolboxBLEConfig">ModusToolbox BT Configurator Tool Guide</ulink><linebreak />
 <ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool Guide</ulink><linebreak />
 <ulink url="https://cypresssemiconductorco.github.io/bless/ble_api_reference_manual/html/index.html">PSoC 6 BLE Middleware API Reference Guide</ulink><linebreak />
 <ulink url="http://www.cypress.com/an210781">AN210781 - Getting Started with PSoC 6 MCU with Bluetooth Low, Energy, (BLE) Connectivity</ulink><linebreak />
 <ulink url="https://github.com/cypresssemiconductorco.github.io/psoc6pdl/pdl_api_reference_manual/html/index.html">PDL API Reference</ulink><linebreak />
 <ulink url="https://www.cypress.com/documentation/technical-reference-manuals/psoc-6-mcu-psoc-63-ble-architecture-technical-reference">PSoC 6 Technical Reference Manual</ulink><linebreak />
 <ulink url="http://www.cypress.com/documentation/software-and-drivers/cysmart-bluetooth-le-test-and-debug-tool">CySmart - BLE Test and Debug Tool</ulink><linebreak />
 <ulink url="http://www.cypress.com/cy8ckit-062-ble">CY8CKIT-062-BLE PSoC 6 BLE Pioneer Kit</ulink><linebreak />
 <ulink url="http://www.cypress.com">Cypress Semiconductor</ulink><linebreak />
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The links to another software component's documentation (middleware and PDL) point to GitHub to the latest available version of the software. To get documentation of the specified version, download from GitHub and unzip the component archive. The documentation is available in the &lt;i&gt;docs&lt;/i&gt; folder. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>